#!/usr/bin/env python
# coding: utf-8

# In[21]:


# Verfahren mit dem Banachschen FP von früher

import numpy as np

def banach(f,x_0,schritte):
    val=[x_0]
    for i in range(schritte):
        val.append(f(val[-1]))
    return val


# In[22]:


# unsere Beispielmatrix
A=np.array([
    [3,2,0],
    [1,5,2],
    [4,-1,7]
])


# In[32]:


# Teste ob A strikt diagonaldominant ist

test = False;

for i in range(3): #teste jede Zeile i
    sum=0          #die Betragssumme der Zeile
    for j in range(3):
        sum+=abs(A[i][j])      #addiere die Beträge der a_(i,j)
    if(sum-2*abs(A[i][i])>=0):        #teste ob die Summe (mit a_(i,i) größer ist als a_(i,i)
        test=True              #hier könnte man auch direkt abbrechen
if test:
    print("A ist nicht strikt diagonaldominant")
else:
    print("A ist strikt diagonaldominant")


# In[33]:


#1. Möglichkeit DI=D^(-1) zu berechnen:
D=np.diag(np.diag(A))
"""
D=np.array([
    [3,0,0],
    [0,5,0],
    [0,0,7]
])
"""
DI=np.linalg.inv(D)
DI


# In[37]:


#Alternative Möglichkeiten
#DI=np.diag([1/3,1/5,1/7])    #explizit
n = len(A)                    #Dimension von A =3
DI=np.zeros((n,n))            # erstellt leere n x n Matrix
for i in range(n):
    #ds.append(1/A[i][i])     #die Inversen Diagonaleinträge direkt erstellen
    DI[i][i]=1/A[i][i]        #oder die leere Matrix direkt befüllen
#DI=np.diag(ds)
print(DI)

#S=I-D^(-1)A und tildeb=D^(-1)b:
S=(np.identity(3)-DI.dot(A))
b=DI.dot(np.array([1,2,3]))
print("\n S=",S,"\n \n tildeb=",b)


# In[26]:


def f(x):          #unsere Iterationsvorschrift
    return S.dot(x)+b


# In[27]:


app=banach(f,np.zeros(3), 10)  #wende den Banachschen FP-Satz an
app


# In[38]:


A.dot(app[-1])         #wie nah liegt Ax bei b?


# In[ ]:




